# $Id: reps.gap,v 1.7 2000/03/24 16:32:32 nathand Exp $

#Read("fox.gap");

# Inducing a representation

#InducedRepresentation := function(G, H, r)
#   local T;
#   # transversal for G/H
#   T := List(RightTransversal(G, U), i -> CanonicalRightCosetElement(U, i) );
#end;

# matrices must be square!

TensorOfMatrices := function(A, B)
  local m, n, T, i, j, k, l;
  m := DimensionsMat(A)[1];
  n := DimensionsMat(B)[1];
  T := NullMat(n*m, n*m);
  for i in [1..m] do
     for j in [1..n] do 
       for k in [1..m] do
          for l in [1..n] do
             T[n*(k-1)+l][n*(i-1)+j] := A[k][i]*B[l][j];
          od;
       od;
     od;
  od;
  return(T);
end;

  
# External Tensor Product -- given G and images of generators ImGen1 and
# ImGen2 constructs the tensor product of the two representations.

TensorOfReps := function(ImGen1, ImGen2)
   return List([1..Length(ImGen1)], i -> TensorOfMatrices(ImGen1[i], ImGen2[i]));
end;

#

TensorListOfMatrices := function(ListOfMat) 
   local Curr, i;
   Curr:= ListOfMat[1];
   for i in [2..Length(ListOfMat)] do
        Curr := TensorOfMatrices(Curr, ListOfMat[i]);
     od;
   return Curr;
end;

TensorListOfBlockMatrices := function(ListOfBlocks) 
   local  n, m, len;
   m := Length(ListOfBlocks[1]);
   n := Length(ListOfBlocks[1][1]);
   return List([1..m], i -> List([1..n], j->
    TensorListOfMatrices(List(ListOfBlocks, B -> B[i][j])))); 
end;

# checks tensor product of subgroups.

CheckProductOfReps := function(G, Q1, U1, Q2, U2, h1, h2)
   local gens, Q, U, e1, e2,h;
   Q := DirectProduct(Q1,Q2);
   e1 := Embedding(Q, 1);
   e2 := Embedding(Q, 2);
   gens := List(GeneratorsOfGroup(U1), u-> Image(e1, u));
   Append(gens, List(GeneratorsOfGroup(U2), u-> Image(e2, u)));
   U := Subgroup(Q, gens);
   h := GroupHomomorphismByImagesNC(G, Q, GeneratorsOfGroup(G), 
    List(GeneratorsOfGroup(G),
      g -> Image(e1, Image(h1, g)) * Image(e2, Image(h2, g))));
   return AbelianRankOfSubgroup(G, PreImage(h, U));
end;
   